diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
index 0b2bae886..2bdaf8aa8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.item.tool;
 
-import java.util.HashMap;
-import java.util.Map;
-
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
@@ -12,7 +11,7 @@ import net.minecraft.core.item.material.ToolMaterial;
 
 public class ItemToolPickaxe extends ItemTool {
 	
-	public static Map<Block<?>, Integer> miningLevels = new HashMap<>();
+	public static final Object2IntMap<Block<?>> miningLevels = new Object2IntOpenHashMap<>();
 	
 	static {
 		miningLevels.put(Blocks.OBSIDIAN, 3);
@@ -56,15 +55,15 @@ public class ItemToolPickaxe extends ItemTool {
 		miningLevels.put(Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, 2);
 	}
 	
-	public ItemToolPickaxe(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial) {
+	public ItemToolPickaxe(final String name, final String namespaceId, final int id, final ToolMaterial enumtoolmaterial) {
 		super(name, namespaceId, id, 2, enumtoolmaterial, BlockTags.MINEABLE_BY_PICKAXE);
 	}
 
 	@Override
-	public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
+	public boolean canHarvestBlock(final Mob mob, final ItemStack itemStack, final Block<?> block)
 	{
-		Integer miningLevel = miningLevels.get(block);
-		if(miningLevel != null) return material.getMiningLevel() >= miningLevel;
+		final int miningLevel = miningLevels.getOrDefault(block, -1);
+		if(miningLevel != -1) return this.material.getMiningLevel() >= miningLevel;
 		
 		return block.hasTag(BlockTags.MINEABLE_BY_PICKAXE);
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeDimension.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeDimension.java
index fc27fffc8..7c4a80c57 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeDimension.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeDimension.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.context.CommandContext;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.suggestion.Suggestions;
 import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.world.Dimension;
@@ -27,8 +28,8 @@ public class ArgumentTypeDimension implements ArgumentType<Dimension> {
     public Dimension parse(StringReader reader) throws CommandSyntaxException {
         final String string = reader.readString();
 
-        for (Map.Entry<Integer, Dimension> dimension : Dimension.getDimensionList().entrySet()) {
-            if (CommandHelper.matchesKeyString(dimension.getValue().languageKey, string) || string.equals(String.valueOf(dimension.getKey()))) {
+        for (Int2ObjectMap.Entry<Dimension> dimension : Dimension.getDimensionList().int2ObjectEntrySet()) {
+            if (CommandHelper.matchesKeyString(dimension.getValue().languageKey, string) || string.equals(String.valueOf(dimension.getIntKey()))) {
                 return dimension.getValue();
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeTime.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeTime.java
index a084a1512..4e4edea84 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeTime.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeTime.java
@@ -8,23 +8,23 @@ import com.mojang.brigadier.exceptions.Dynamic2CommandExceptionType;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.brigadier.suggestion.Suggestions;
 import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.util.CommandHelper;
 
 import java.util.Arrays;
 import java.util.Collection;
-import java.util.HashMap;
-import java.util.Map;
 import java.util.concurrent.CompletableFuture;
 
 public class ArgumentTypeTime implements ArgumentType<Integer> {
     private static final Collection<String> EXAMPLES = Arrays.asList("0d", "0s", "0t", "0");
     private static final SimpleCommandExceptionType ERROR_INVALID_UNIT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.time.invalid_unit"));
     private static final Dynamic2CommandExceptionType ERROR_TICK_COUNT_TOO_LOW = new Dynamic2CommandExceptionType((object, object2) -> () -> I18n.getInstance().translateKeyAndFormat("command.argument_types.time.tick_count_too_low", object2, object));
-    private static final Map<String, Integer> UNITS = new HashMap<>();
+    private static final Object2IntMap<String> UNITS = new Object2IntArrayMap<>();
     final int minimum;
 
-    private ArgumentTypeTime(int i) {
+    private ArgumentTypeTime(final int i) {
         this.minimum = i;
     }
     
@@ -32,19 +32,19 @@ public class ArgumentTypeTime implements ArgumentType<Integer> {
         return new ArgumentTypeTime(Integer.MIN_VALUE);
     }
 
-    public static ArgumentTypeTime time(int i) {
+    public static ArgumentTypeTime time(final int i) {
         return new ArgumentTypeTime(i);
     }
 
     @Override
-    public Integer parse(StringReader stringReader) throws CommandSyntaxException {
-        float f = stringReader.readFloat();
-        String string = stringReader.readUnquotedString();
-        int i = UNITS.getOrDefault(string, 0);
+    public Integer parse(final StringReader stringReader) throws CommandSyntaxException {
+        final float f = stringReader.readFloat();
+        final String string = stringReader.readUnquotedString();
+        final int i = UNITS.getOrDefault(string, 0);
         if (i == 0) {
             throw ERROR_INVALID_UNIT.create();
         }
-        int j = Math.round(f * (float)i);
+        final int j = Math.round(f * (float)i);
         if (j < this.minimum) {
             throw ERROR_TICK_COUNT_TOO_LOW.create(j, this.minimum);
         }
@@ -52,11 +52,11 @@ public class ArgumentTypeTime implements ArgumentType<Integer> {
     }
 
     @Override
-    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> commandContext, SuggestionsBuilder suggestionsBuilder) {
-        StringReader stringReader = new StringReader(suggestionsBuilder.getRemaining());
+    public <S> CompletableFuture<Suggestions> listSuggestions(final CommandContext<S> commandContext, final SuggestionsBuilder suggestionsBuilder) {
+        final StringReader stringReader = new StringReader(suggestionsBuilder.getRemaining());
         try {
             stringReader.readFloat();
-        } catch (CommandSyntaxException commandSyntaxException) {
+        } catch (final CommandSyntaxException commandSyntaxException) {
             return suggestionsBuilder.buildFuture();
         }
         return CommandHelper.suggest(UNITS.keySet(), suggestionsBuilder.createOffset(suggestionsBuilder.getStart() + stringReader.getCursor()));
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java b/game/core/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java
index 6fb79088c..60078ff34 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java
@@ -15,6 +15,12 @@ import com.mojang.nbt.tags.ShortArrayTag;
 import com.mojang.nbt.tags.ShortTag;
 import com.mojang.nbt.tags.StringTag;
 import com.mojang.nbt.tags.Tag;
+import it.unimi.dsi.fastutil.bytes.ByteArrayList;
+import it.unimi.dsi.fastutil.bytes.ByteList;
+import it.unimi.dsi.fastutil.doubles.DoubleArrayList;
+import it.unimi.dsi.fastutil.doubles.DoubleList;
+import it.unimi.dsi.fastutil.shorts.ShortArrayList;
+import it.unimi.dsi.fastutil.shorts.ShortList;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 
 import java.util.ArrayList;
@@ -86,7 +92,7 @@ public class NbtHelper {
             if (reader.peek() == ']') return new ByteArrayTag();
             else if (reader.peek() == ';') {
                 reader.skip();
-                List<Byte> bytes = new ArrayList<>();
+                ByteList bytes = new ByteArrayList();
                 while (reader.canRead() && reader.peek() != ']') {
                     reader.skipWhitespace();
                     String byteAsString = reader.readString();
@@ -100,7 +106,7 @@ public class NbtHelper {
                 reader.skipWhitespace();
                 if (reader.canRead() && reader.peek() == ']') {
                     reader.skip();
-                    return new ByteArrayTag(byteListToArray(bytes));
+                    return new ByteArrayTag(bytes.toByteArray());
                 }
                 throw CommandExceptions.expectedEndOfTag().create();
             }
@@ -114,7 +120,7 @@ public class NbtHelper {
             }
             else if (reader.peek() == ';') {
                 reader.skip();
-                List<Short> shorts = new ArrayList<>();
+                ShortList shorts = new ShortArrayList();
                 while (reader.canRead() && reader.peek() != ']') {
                     reader.skipWhitespace();
                     String shortAsString = reader.readString();
@@ -129,7 +135,7 @@ public class NbtHelper {
 
                 if (reader.canRead() && reader.peek() == ']') {
                     reader.skip();
-                    return new ShortArrayTag(shortListToArray(shorts));
+                    return new ShortArrayTag(shorts.toShortArray());
                 }
                 else throw CommandExceptions.expectedEndOfTag().create();
             }
@@ -143,7 +149,7 @@ public class NbtHelper {
             }
             else if (reader.peek() == ';') {
                 reader.skip();
-                List<Double> doubles = new ArrayList<>();
+                DoubleList doubles = new DoubleArrayList();
                 while (reader.canRead() && reader.peek() != ']') {
                     reader.skipWhitespace();
                     String doubleAsString = reader.readString();
@@ -162,7 +168,7 @@ public class NbtHelper {
                 reader.skipWhitespace();
                 if (reader.canRead() && reader.peek() == ']') {
                     reader.skip();
-                    return new DoubleArrayTag(doubles.stream().mapToDouble(Double::doubleValue).toArray());
+                    return new DoubleArrayTag(doubles.toDoubleArray());
                 }
                 else throw CommandExceptions.expectedEndOfTag().create();
             }
@@ -185,26 +191,6 @@ public class NbtHelper {
         throw CommandExceptions.incomplete().create();
     }
 
-    private static short[] shortListToArray(List<Short> shorts) {
-        short[] arr = new short[shorts.size()];
-
-        for (int i = 0; i < shorts.size(); i++) {
-            arr[i] = shorts.get(i);
-        }
-
-        return arr;
-    }
-
-    private static byte[] byteListToArray(List<Byte> bytes) {
-        byte[] arr = new byte[bytes.size()];
-
-        for (int i = 0; i < bytes.size(); i++) {
-            arr[i] = bytes.get(i);
-        }
-
-        return arr;
-    }
-
     private static Tag<?> type(String string) {
         try {
             if ("true".equalsIgnoreCase(string)) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index de6868f89..18413628b 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.net.entity;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.net.entity.entries.NetEntryAnimal;
 import net.minecraft.core.net.entity.entries.NetEntryArrow;
 import net.minecraft.core.net.entity.entries.NetEntryBoat;
@@ -32,8 +36,8 @@ public class NetEntityHandler {
     private static final List<INetworkEntry<?>> netEntries = new ArrayList<>();
     private static final List<IPacketEntry<?>> packetEntries = new ArrayList<>();
     private static final List<ITrackedEntry<?>> trackedEntries = new ArrayList<>();
-    private static final Map<Integer, IVehicleEntry<?>> typeToProviderMap = new HashMap<>();
-    private static final Map<IVehicleEntry<?>, Integer> providerToTypeMap = new HashMap<>();
+    private static final Int2ObjectMap<IVehicleEntry<?>> typeToProviderMap = new Int2ObjectArrayMap<>();
+    private static final Object2IntMap<IVehicleEntry<?>> providerToTypeMap = new Object2IntArrayMap<>();
     private static boolean isListDirty = false;
     public static <T> void registerNetworkEntry(INetworkEntry<T> networkEntity){
         addEntryRaw(networkEntity, -1);
@@ -52,7 +56,7 @@ public class NetEntityHandler {
             entryClassMap.remove(entityClass);
 
             if (type >= 0 && typeToProviderMap.containsKey(type)){
-                providerToTypeMap.remove(typeToProviderMap.remove(type));
+                providerToTypeMap.removeInt(typeToProviderMap.remove(type));
             }
         }
         entryClassMap.put(entityClass, entry);
@@ -83,7 +87,7 @@ public class NetEntityHandler {
             if (netEnt.getAppliedClass().isAssignableFrom(trackerEntry.getTrackedEntity().getClass())){
                 Packet packet;
                 if (netEnt instanceof IVehicleEntry){
-                    packet = ((IVehicleEntry)netEnt).getSpawnPacket(trackerEntry, trackerEntry.getTrackedEntity()).setType(providerToTypeMap.get(netEnt));
+                    packet = ((IVehicleEntry)netEnt).getSpawnPacket(trackerEntry, trackerEntry.getTrackedEntity()).setType(providerToTypeMap.getInt(netEnt));
                 } else {
                     packet = netEnt.getSpawnPacket(trackerEntry, trackerEntry.getTrackedEntity());
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index 88a4042c9..ebb157a66 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -3,6 +3,17 @@ package net.minecraft.core.net.packet;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMaps;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntArrays;
+import it.unimi.dsi.fastutil.ints.IntList;
+import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
+import it.unimi.dsi.fastutil.ints.IntSet;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMaps;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.handler.PacketHandler;
 import org.slf4j.Logger;
@@ -16,22 +27,17 @@ import java.io.EOFException;
 import java.io.IOException;
 import java.nio.charset.StandardCharsets;
 import java.util.Arrays;
-import java.util.Collections;
-import java.util.HashMap;
-import java.util.HashSet;
 import java.util.List;
-import java.util.Map;
-import java.util.Set;
 import java.util.UUID;
 
 public abstract class Packet
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private static final List<Integer> INTERESTING_PACKETS = Arrays.asList(50, 51, 52);
-    private static final Map<Integer, Class<? extends Packet>> packetIdToClassMap = new HashMap<>();
-    private static final Map<Class<? extends Packet>, Integer> packetClassToIdMap = new HashMap<>();
-    private static final Set<Integer> clientBoundPacketIds = new HashSet<>();
-    private static final Set<Integer> serverBoundPacketIds = new HashSet<>();
+    private static final IntList INTERESTING_PACKETS = IntArrayList.of(50, 51, 52);
+    private static final Int2ObjectMap<Class<? extends Packet>> packetIdToClassMap = new Int2ObjectOpenHashMap<>();
+    private static final Object2IntMap<Class<? extends Packet>> packetClassToIdMap = new Object2IntOpenHashMap<>();
+    private static final IntSet clientBoundPacketIds = new IntOpenHashSet();
+    private static final IntSet serverBoundPacketIds = new IntOpenHashSet();
 
     public static final int MAX_USERNAME_SIZE = 16;
     public static final int MAX_NICKNAME_SIZE = 256;
@@ -82,7 +88,7 @@ public abstract class Packet
 
     public final int getId()
     {
-        return packetClassToIdMap.get(getClass());
+        return packetClassToIdMap.getInt(getClass());
     }
 
     public static Packet readPacket(DataInputStream dis, boolean isServer) throws IOException {
@@ -229,12 +235,12 @@ public abstract class Packet
         return new UUID(msb, lsb);
     }
 
-    public static Map<Class<? extends Packet>, Integer> getPacketClassToIdMap() {
-        return Collections.unmodifiableMap(packetClassToIdMap);
+    public static Object2IntMap<Class<? extends Packet>> getPacketClassToIdMap() {
+        return Object2IntMaps.unmodifiable(packetClassToIdMap);
     }
 
-    public static Map<Integer, Class<? extends Packet>> getPacketIdToClassMap() {
-        return Collections.unmodifiableMap(packetIdToClassMap);
+    public static Int2ObjectMap<Class<? extends Packet>> getPacketIdToClassMap() {
+        return Int2ObjectMaps.unmodifiable(packetIdToClassMap);
     }
 
     public abstract void read(DataInputStream dis)
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
index 1504f896e..d37e8f14a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
@@ -7,6 +7,8 @@ import java.util.HashMap;
 import java.util.Map;
 import java.util.Map.Entry;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.net.handler.PacketHandler;
 
 public class PacketSyncIDs extends Packet {
@@ -17,19 +19,19 @@ public class PacketSyncIDs extends Packet {
 	private int packetSize;
 
 	public int destinationId = -1;
-	public Map<Integer, String> mapping;
+	public Int2ObjectMap<String> mapping;
 
 	public PacketSyncIDs() {
 
 	}
 
-	public PacketSyncIDs(int destinationId, Map<Integer, String> mapping) {
+	public PacketSyncIDs(final int destinationId, final Int2ObjectMap<String> mapping) {
 		this.destinationId = destinationId;
 		this.mapping = mapping;
 	}
 
 	@Override
-	public void read(DataInputStream in) throws IOException {
+	public void read(final DataInputStream in) throws IOException {
 		int size = 0;
 		
 		size += readIds(in);
@@ -38,7 +40,7 @@ public class PacketSyncIDs extends Packet {
 	}
 
 	@Override
-	public void write(DataOutputStream out) throws IOException {
+	public void write(final DataOutputStream out) throws IOException {
 		int size = 0;
 		
 		size += writeIds(out);
@@ -46,33 +48,33 @@ public class PacketSyncIDs extends Packet {
 		this.packetSize = size;
 	}
 	
-	public int readIds(DataInputStream in) throws IOException {
-		this.mapping = new HashMap<>();
+	public int readIds(final DataInputStream in) throws IOException {
+		this.mapping = new Int2ObjectOpenHashMap<>();
 		
 		int bytesRead = 0;
 
 		this.destinationId = in.readByte() & 0xFF;
-		int count = in.readInt();
+		final int count = in.readInt();
 		bytesRead += 4;
 		
 		for(int i=0; i < count; i++) {
-			int id = in.readShort() & 0xFFFF;
-			String name = readStringUTF8(in, MAX_ID_STRING_SIZE);
-			mapping.put(id, name);
+			final int id = in.readShort() & 0xFFFF;
+			final String name = readStringUTF8(in, MAX_ID_STRING_SIZE);
+            this.mapping.put(id, name);
 		}
 		
 		return bytesRead;
 	}
 	
-	public int writeIds(DataOutputStream out) throws IOException {
+	public int writeIds(final DataOutputStream out) throws IOException {
 		int bytesWritten = 0;
 
-		out.writeByte(destinationId);
-		out.writeInt(mapping.size());
+		out.writeByte(this.destinationId);
+		out.writeInt(this.mapping.size());
 		bytesWritten += 4;
 		
-		for(Entry<Integer, String> entry : mapping.entrySet()) {
-			out.writeShort(entry.getKey());
+		for(final Int2ObjectMap.Entry<String> entry : this.mapping.int2ObjectEntrySet()) {
+			out.writeShort(entry.getIntKey());
 			writeStringUTF8(entry.getValue(), out);
 		}
 		
@@ -80,13 +82,13 @@ public class PacketSyncIDs extends Packet {
 	}
 
 	@Override
-	public void handlePacket(PacketHandler packetHandler) {
+	public void handlePacket(final PacketHandler packetHandler) {
 		packetHandler.handleIds(this);
 	}
 
 	@Override
 	public int getEstimatedSize() {
-		return packetSize + 1;
+		return this.packetSize + 1;
 	}
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 995214f2b..694159663 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -3,12 +3,13 @@ package net.minecraft.core.player.inventory.menu;
 import java.util.*;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.Global;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -113,7 +114,7 @@ public abstract class MenuAbstract
 	public Slot getSlot(int i)
 	{
 		try{
-			return (Slot) slots.get(i);
+			return slots.get(i);
 		}catch (Exception e) {
 			return null;
 		}
@@ -481,8 +482,8 @@ public abstract class MenuAbstract
 		if(action == InventoryAction.MOVE_SINGLE_ITEM || action == InventoryAction.MOVE_STACK) {
 			if(stackInSlot == null) return;
 
-			List<Integer> targetSlots = getTargetSlots(action, slot, target, player);
-			if(targetSlots == null || targetSlots.size() == 0) {
+			IntList targetSlots = getTargetSlots(action, slot, target, player);
+			if(targetSlots == null || targetSlots.isEmpty()) {
 				return;
 			}
 
@@ -508,8 +509,8 @@ public abstract class MenuAbstract
 		}
 
 		if(action == InventoryAction.MOVE_ALL || action == InventoryAction.MOVE_SIMILAR) {
-			List<Integer> moveSlots = getMoveSlots(action, slot, target, player);
-			List<Integer> targetSlots = getTargetSlots(action, slot, target, player);
+			IntList moveSlots = getMoveSlots(action, slot, target, player);
+			IntList targetSlots = getTargetSlots(action, slot, target, player);
 
 			if(moveSlots == null || targetSlots == null) return;
 
@@ -576,7 +577,7 @@ public abstract class MenuAbstract
 			return;
 		}
 
-		List<Integer> resultSlots = getTargetSlots(action, slot, target, player);
+		IntList resultSlots = getTargetSlots(action, slot, target, player);
 		if(resultSlots == null) {
 			return;
 		}
@@ -610,7 +611,7 @@ public abstract class MenuAbstract
 	 * Returns the amount of space available for the given item in the given slots.
 	 * Stops when max stack size is reached.
 	 */
-	public int getFreeSpace(ItemStack item, List<Integer> slots) {
+	public int getFreeSpace(ItemStack item, IntList slots) {
 		int space = 0;
 		int max = item.getMaxStackSize();
 
@@ -636,16 +637,16 @@ public abstract class MenuAbstract
 	}
 
 	/**
-	 * Slots to move items from when using MOVE_ALL or MOVE_SIMILAR.
-	 * If the return value is null, MOVE_ALL and MOVE_SIMILAR won't do anything!
-	 */
-	public abstract List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player);
+     * Slots to move items from when using MOVE_ALL or MOVE_SIMILAR.
+     * If the return value is null, MOVE_ALL and MOVE_SIMILAR won't do anything!
+     */
+	public abstract IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player);
 
 	/**
 	 * Slots to move items to when using any MOVE action.
 	 * If the return value is null, all MOVE actions won't do anything!
 	 */
-	public abstract List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player);
+	public abstract IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player);
 
 	/**
 	 * Pick up all items similar to the one the player is holding.
@@ -843,7 +844,7 @@ public abstract class MenuAbstract
 	 * Merge the given ItemStack into the given slots.
 	 * First merge with items that can stack with the one given, then into empty slots
 	 */
-	public final void mergeItems(ItemStack stack, List<Integer> targetSlots) {
+	public final void mergeItems(ItemStack stack, IntList targetSlots) {
 		if(stack == null || targetSlots == null) return;
 
 		for(int i = 0; i < targetSlots.size(); i++) {
@@ -886,8 +887,8 @@ public abstract class MenuAbstract
 	 * Crash in development mode so its obvious something is wrong.
 	 * When not in development just skip this slot
 	 */
-	public Slot getSlotFromList(List<Integer> slots, int i) {
-		int slotId = slots.get(i);
+	public Slot getSlotFromList(IntList slots, int i) {
+		int slotId = slots.getInt(i);
 		Slot slot = getSlot(slotId);
 		if(slot == null && Global.BUILD_CHANNEL.isUnstableBuild()) {
 			throw new NullPointerException("Slot "+slotId+" does not exist!");
@@ -896,7 +897,7 @@ public abstract class MenuAbstract
 	}
 
 	public final void mergeItems(ItemStack stack, int targetSlot) {
-		List<Integer> list = new ArrayList<>();
+		IntList list = new IntArrayList();
 		list.add(targetSlot);
 		mergeItems(stack, list);
 	}
@@ -905,11 +906,11 @@ public abstract class MenuAbstract
 		mergeItems(stack, getSlots(minSlot, (maxSlot - minSlot) + 1, lastSlotFirst));
 	}
 
-	public List<Integer> getSlots(int min, int count, boolean lastSlotsFirst) {
-		return getSlots(new ArrayList<>(), min, count, lastSlotsFirst);
+	public IntList getSlots(int min, int count, boolean lastSlotsFirst) {
+		return getSlots(new IntArrayList(), min, count, lastSlotsFirst);
 	}
 
-	public List<Integer> getSlots(List<Integer> targetSlots, int min, int count, boolean lastSlotsFirst) {
+	public IntList getSlots(IntList targetSlots, int min, int count, boolean lastSlotsFirst) {
 		for(int i = 0; i < count; i++) {
 			targetSlots.add(lastSlotsFirst ? min + count - 1 - i : min + i);
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
index 9a786aa01..ca13ca28a 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.crafting.ContainerListener;
@@ -8,8 +9,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-import java.util.List;
-
 public class MenuActivator extends MenuAbstract {
 	public static final int ID_SELECTOR = 0;
 	public static final int ID_LOCKED_SLOTS = 1;
@@ -86,7 +85,7 @@ public class MenuActivator extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(activatorSlotsStart, 9, false);
 		}
@@ -108,7 +107,7 @@ public class MenuActivator extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(inventorySlotsStart, 36, false);
 		}else {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
index eb231d31c..207c66d2b 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
-import java.util.List;
-
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
@@ -42,7 +41,7 @@ public class MenuContainer extends MenuAbstract {
 	}
 	
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
 		if(slot.index >= 0 && slot.index < chestSize) {
@@ -70,7 +69,7 @@ public class MenuContainer extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
 		if(slot.index < chestSize) {
